"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactDom = require("react-dom");

var _ListHeader = _interopRequireDefault(require("./lib/ListHeader"));

var _ListItems = _interopRequireDefault(require("./lib/ListItems"));

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) {
  function isNativeReflectConstruct() {
    if (typeof Reflect === "undefined" || !Reflect.construct) return false;
    if (Reflect.construct.sham) return false;
    if (typeof Proxy === "function") return true;

    try {
      Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));
      return true;
    } catch (e) {
      return false;
    }
  }

  return function () {
    var Super = _getPrototypeOf(Derived),
        result;

    if (isNativeReflectConstruct()) {
      var NewTarget = _getPrototypeOf(this).constructor;

      result = Reflect.construct(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }

    return _possibleConstructorReturn(this, result);
  };
}

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var ReactListView = /*#__PURE__*/function (_Component) {
  _inherits(ReactListView, _Component);

  var _super = _createSuper(ReactListView);

  function ReactListView(props) {
    var _this;

    _classCallCheck(this, ReactListView);

    _this = _super.call(this, props);
    _this.state = {
      events: ['scroll', 'mousewheel', 'DOMMouseScroll', 'MozMousePixelScroll', 'resize', 'touchmove', 'touchend'],
      _firstChildWrapper: '',
      _headerFixedPosition: '',
      _instances: {}
    };
    return _this;
  }

  _createClass(ReactListView, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.initStickyHeaders();
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var _this2 = this;

      // unRegister events listeners with the listview div
      this.state.events.forEach(function (type) {
        if (window.addEventListener) {
          (0, _reactDom.findDOMNode)(_this2.refs.listview).removeEventListener(type, _this2.onScroll.bind(_this2), false);
        } else {
          (0, _reactDom.findDOMNode)(_this2.refs.listview).detachEvent('on' + type, _this2.onScroll.bind(_this2), false);
        }
      });
    }
  }, {
    key: "refsToArray",
    value: function refsToArray(ctx, prefix) {
      var results = [];

      for (var i = 0;; i++) {
        var ref = ctx.refs[prefix + '-' + String(i)];
        if (ref) results.push(ref);else return results;
      }
    }
  }, {
    key: "initStickyHeaders",
    value: function initStickyHeaders() {
      var _this3 = this;

      var listHeaders = this.refsToArray(this, 'ListHeader');

      var _originalPositions = listHeaders.map(function (l) {
        var headerAndPosInfo = {
          headerObj: l,
          originalPosition: l.refs.header.getBoundingClientRect().top
        };
        return headerAndPosInfo;
      });

      this.setState({
        _instances: Object.assign(this.state._instances, {
          _originalPositions: _originalPositions
        }),
        _firstChildWrapper: listHeaders[0].refs.followWrap,
        _headerFixedPosition: listHeaders[0].refs.header.getBoundingClientRect().top
      }); // Register events listeners with the listview div

      this.state.events.forEach(function (type) {
        if (window.addEventListener) {
          (0, _reactDom.findDOMNode)(_this3.refs.listview).addEventListener(type, _this3.onScroll.bind(_this3), false);
        } else {
          (0, _reactDom.findDOMNode)(_this3.refs.listview).attachEvent('on' + type, _this3.onScroll.bind(_this3), false);
        }
      });
    }
  }, {
    key: "onScroll",
    value: function onScroll() {
      var _this4 = this;

      // update current header positions and apply fixed positions to the top one
      var currentWindowScrollTop = this.state._headerFixedPosition - this.state._firstChildWrapper.getBoundingClientRect().top;

      this.state._instances._originalPositions.forEach(function (c, index) {
        var currentNode = c.headerObj.refs.header;
        var currentHeaderHeight = parseInt(currentNode.style.height, 10);
        var nextNode = null;
        var topPos = null;
        var ignoreCheck = false;

        if (index < _this4.state._instances._originalPositions.length - 1) {
          nextNode = _this4.state._instances._originalPositions[index + 1];
        }

        if (index === 0 && currentWindowScrollTop === c.originalPosition) {
          currentNode.style.position = '';
          ignoreCheck = true;
        }

        if (!ignoreCheck && c.originalPosition < currentWindowScrollTop + _this4.state._headerFixedPosition + index * currentHeaderHeight) {
          Object.assign(currentNode.style, _this4.props.styles.fixedPosition); // apply top value

          currentNode.style.top = "".concat(_this4.state._headerFixedPosition, "px");

          if (currentWindowScrollTop + index * currentHeaderHeight > nextNode.originalPosition) {
            currentNode.style.position = 'absolute';
            currentNode.style.top = "".concat(topPos, "px");
          }
        } else {
          currentNode.style.position = '';
        }
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          data = _this$props.data,
          headerAttName = _this$props.headerAttName,
          itemsAttName = _this$props.itemsAttName;
      var _this$props$styles = this.props.styles,
          outerDiv = _this$props$styles.outerDiv,
          ul = _this$props$styles.ul,
          listHeader = _this$props$styles.listHeader,
          listItems = _this$props$styles.listItems,
          li = _this$props$styles.li;
      var _refi = 0;

      var makeRef = function makeRef() {
        return "ListHeader-".concat(_refi++);
      };

      return _react["default"].createElement("div", {
        ref: "listview",
        style: outerDiv
      }, _react["default"].createElement("ul", {
        style: ul
      }, Object.keys(data).map(function (k) {
        var header = data[k][headerAttName];
        var items = data[k][itemsAttName];
        return _react["default"].createElement("li", {
          key: k
        }, _react["default"].createElement(_ListHeader["default"], {
          ref: makeRef(),
          header: header,
          styles: listHeader
        }), _react["default"].createElement(_ListItems["default"], {
          items: items,
          styles: listItems
        }));
      })));
    }
  }]);

  return ReactListView;
}(_react.Component);

exports["default"] = ReactListView;

_defineProperty(ReactListView, "propTypes", {
  data: _propTypes["default"].array.isRequired,
  headerAttName: _propTypes["default"].string.isRequired,
  itemsAttName: _propTypes["default"].string.isRequired,
  styles: _propTypes["default"].object.isRequired
});
//# sourceMappingURL=ReactListView.js.map